program menu;
uses tpcrt,tpstring,TpInline;
var items:array[1..16]of record
                          s:string[80];
                          l:byte;
                          x:byte;
                          y:byte;
                         end;
const Frame:(Noframe,SingleFrame,DoubleFrame)=NoFrame;
      Orientation:(Vertical,Horizontal)=Vertical;
      GoForWard:word=$4800;
      BackWard:word=$5000;
      Row:byte=1;
      Choice:byte=1;
var   Status:(NoItem,Item);
      Col:byte;
      cmdptr:^string;
      cmdlin:string;
      i,n,j:integer;
      s:string;
      Fr,fb,fl:byte;
      maxl:byte;
      Attr,SelectedAttr,SaveAttr:byte;
procedure menuhelp;external;
{$L menuhelp.obj}
procedure display(p:pointer);inline(
$5a/     {Pop DX}
$1f/     {Pop Ds}
$b4/$09/ {Mov ah,09}
$cd/$21);{int 21h}

procedure help(msg:string);
begin
Writeln('Vitus Batch Menu. Version 1.00 CopyRight (c) by Vitus B.Wagner, 1992');
if msg<>'' then Writeln('ERROR:',msg);
display(@menuhelp);
halt
end;
function ExtractValue:integer;
var a:longint;
    i:byte;
begin
  i:=pos('=',s);
  if i=0 then help('Number in option omitted');
  if not Str2Long(copy(s,i+1,255),a) then help ('Invalid Number');
  ExtractValue:=a
end;
function ExtractHexValue:integer;
var a:longint;
    i:byte;
begin
  i:=pos('=',s);
  if i=0 then help('Number in option omitted');
  if not Str2Long('$'+copy(s,i+1,255),a) then help ('Invalid Hexadecimal Number');
  ExtractHexValue:=a
end;
begin
 SaveAttr:=TextAttr;
 cmdptr:=Ptr(PrefixSeg,$80);
 cmdLin:=Trim(StringFromHeap(CmdPtr));
 if (CmdLin='?')or (CmdLin='')or (CmdLin='/?') then help('');
 {Parse Command Line}
 {Parse items}
 n:=0;
 Status:=NoItem;
 For i:=1 to length(CmdLin) do
   if CmdLin[i]='"' then
    if status=Noitem then
     begin
      Status:=item;
      inc(n);
      items[n].x:=i+1;
     end
    else
     begin
      Status:=NoItem;
      Items[n].y:=i+1;
      Items[n].l:=i-items[n].x
     end;
  if Status=Item then Help('End of Item not found');
  maxl:=0;
  for i:=1 to n do
   begin
   Items[i].s:=copy(CmdLin,Items[i].x,Items[i].l);
   if Items[i].l>maxl then MaxL:=Items[i].l
   end;
  Attr:=TextAttr;
  SelectedAttr:=SwapNibble(Attr) and $7F;
  col:=40 - maxL div 2;
 {Parse Options}
 cmdLin:=StUpCase(Copy(CmdLin,Items[n].y,255));
 for i:=1 to wordCount(CmdLin,[' ', ',',';','.','/']) do
  begin
   s:=ExtractWord(i,CmdLin,[' ', ',',';','.','/']);
   case s[1] of
   'F':Frame:=SingleFrame;
   'D':Frame:=DoubleFrame;
   'H':begin
        Orientation:=Horizontal;
        GoForWard:=$4D00;
        BackWard:=$4B00;
       end;
   'V':begin
       Orientation:=Vertical;
        GoForWard:=$4800;
        BackWard:=$5000;
       end;

   'R':Row:=ExtractValue;
   'C':Col:=ExtractValue;
   'A':Attr:=ExtractHexValue;
   'S':SelectedAttr:=ExtractHexValue;
   'B':begin
        Choice:=ExtractValue;
        if (Choice<=0)or(Choice>n) then
         Help('Invalid initial choice');
       end;
   else
    help('Invalid Command Line option');
  end;
 end;
  {Display Menu}
  if Orientation=Horizontal then
   begin
     WindMin:=word(row) shl 8+2;
     WindMax:=word(row) shl 8+items[n].y-1;
     col:=2;
     if frame<>Noframe then begin
      j:=row+1;
      inc(WindMin,256);
      inc(WindMax,256);
      fr:=Items[n].y;
      fb:=row+2;
      fl:=1;
     end;
     for i:=1 to n do

       Items[i].y := j
   end
  else
   begin
    WindMin:=word(row) shl 8 +col;
    WindMax:=Word(row+n-1) shl 8 +col +maxl-1;
    If Frame<>NoFrame then
     begin
      inc(WindMin,256);
      inc(WindMax,256);
      j:=row+1;
      fr:=col+Maxl;
      fl:=col-1;
      fb:=row+n+1;
     end
     else j:=row;

    for i:=1 to n do
    begin
     Items[i].x:=col;
     Items[i].y:=j;
     inc(j);
     Items[i].l:=maxl;
     Items[i].s:=Pad(Items[i].s,maxl);
    end
  end;
 Case Frame of
 SingleFrame:FrameChars:='ĳ';
 DoubleFrame:FrameChars:='Ȼͺ';
 end;
 if frame<>NoFrame then FrameWindow(Fl,Row,Fr,Fb,attr,attr,'');
 TextAttr:=Attr;
 HiddenCursor;
 Dec(WindMin,$101);
 Dec(WindMax,$101);
 ClrScr;
 for i:=1 to n do
  With Items[i] do
   FastWrite(s,y,x,attr);
 Repeat
  With Items[Choice] do
   FastWrite(s,y,x,SelectedAttr);
   i:=ReadKeyWord;
  With Items[Choice] do
   FastWrite(s,y,x,attr);
  case i of
  $4D00,$5000:if choice=n then choice:=1 else inc(choice);
  $4800,$4B00:if choice=1 then choice:=n else dec(choice);
  $4700:choice:=n;
  $4e00:choice:=1;
  $11b:choice:=0;
  end;
 until (i=$1c0d)or (i=$11b);
 TextAttr:=SaveAttr;
 NormalCursor;
 halt(choice)
end.


